/*
    chassis_ctrl Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "module/chassic.h"
#include "module/config.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
Chassis_CMD_t c_cmd;
Chassis_t chassis;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_chassis_ctrl(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / CHASSIS_CTRL_FREQ;

  osDelay(CHASSIS_CTRL_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
 chassis_init(&chassis, &Config_GetRobotParam()->chassis, CHASSIS_CTRL_FREQ);
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
     osMessageQueueGet(task_runtime.msgq.chassic.cmd, &c_cmd, NULL, 0) ;
    // 成功接收到命令，更新底盘命令
    if (osMessageQueueGet(task_runtime.msgq.chassic.cmd, &c_cmd, NULL, 0) == osOK)
    {
      Chassis_update(&chassis);
      Chassis_Control(&chassis, &c_cmd);
    }
    else
{
    // 如果没有收到命令，可以执行一个安全停止的逻辑
    // 或者什么都不做，让底盘保持上一帧的状态（取决于你的设计）
    // 一个安全的选择是让底盘停止
    Chassis_CMD_t safe_cmd = {.mode = STOP, .Vx = 0, .Vy = 0, .Vw = 0};
    Chassis_Control(&chassis, &safe_cmd);
}
		Chassis_Setoutput(&chassis);

		osMessageQueueReset(task_runtime.msgq.chassic.state);
    osMessageQueuePut(task_runtime.msgq.chassic.state,&chassis, 0, 0);		
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}